package exceptionmanager.handler;

import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

public abstract class AbstractHandlerException implements IHandlerException{

	public final String USE_EXCEPTION_MESSAGE = "USE_EXCEPTION_MESSAGE";
	private Map<Class<?>,String> mapExceptions;
	
	protected abstract Map<Class<?>, String> constructMessageFromExceptionClass();
	
	public AbstractHandlerException()
	{
		setMapExceptions(new LinkedHashMap<Class<?>, String>());
		getExceptionsMap().putAll(constructMessageFromExceptionClass());
	}

	public Set<Class<?>> getExceptionsSet() {
		return mapExceptions.keySet();
	}

	public void setMapExceptions(Map<Class<?>, String> setExceptions) {
		this.mapExceptions = setExceptions;
	}

	@Override
	public String getExceptionMessage(Throwable e) {
		String msg = mapExceptions.get(e.getClass());
		if(msg.equals(USE_EXCEPTION_MESSAGE))
			msg = e.getMessage();
		
		return msg;
	}

	@Override
	public Map<Class<?>, String> getExceptionsMap() {
		return mapExceptions;
	}
}
